window.Gleam.initSearch([{"doc":"glimpse","title":"glimpse","content":"# Glimpse\n\nPerhaps, a library for parsing and typechecking a gleam project. Wraps the AST\nproduced by [glance](https://hex.pm/packages/glance) with two pieces:\n\n- Ability to represent and introspect a gleam program (multiple interdependent\n  modules) as opposed to just one module.\n- Typechecking both within and between modules.\n\nCurrently only focused on the first bit!\n\nThis package is not filesystem aware. That means all modules need to be loaded\nexternally, but it does provide tooling to determine what dependencies need\nto be loaded.\n\n## Development\n\n```sh\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"glimpse","title":"glimpse","content":"","url":"glimpse.html"},{"doc":"glimpse/package","title":"LoadError","content":"pub type LoadError(a) {\n  LoadError(a)\n  ParseError(glance.Error)\n}\n\nLoadError(a)\n\n\nParseError(glance.Error)\n\n\nSynonyms:\nglimpse/package.LoadError\nglimpse/package LoadError","url":"glimpse/package.html#LoadError"},{"doc":"glimpse/package","title":"Module","content":"pub type Module {\n  Module(\n    name: String,\n    module: glance.Module,\n    dependencies: List(String),\n  )\n}\n\nModule(\n  name: String,\n  module: glance.Module,\n  dependencies: List(String),\n)\n A Module is a wrapper of a glance.Module, but maintains some additional\n information such as the name of the package and the names of any dependencies\n of that module.\n\nSynonyms:\nglimpse/package.Module\nglimpse/package Module","url":"glimpse/package.html#Module"},{"doc":"glimpse/package","title":"Package","content":"pub type Package {\n  Package(name: String, modules: dict.Dict(String, Module))\n}\n\nPackage(name: String, modules: dict.Dict(String, Module))\n A Package has a name and a collection of modules. Each module is named\n according to its import. A module can be converted to a filename\n(relative to the global source / directory) simply by appending &#39;.gleam&#39;\n\nSynonyms:\nglimpse/package.Package\nglimpse/package Package","url":"glimpse/package.html#Package"},{"doc":"glimpse/package","title":"filter_new_dependencies","content":"pub fn filter_new_dependencies(\n  module: Module,\n  package: Package,\n) -&gt; List(String)\n given a module and package, identify any dependencies in the module that\n are *not* present in the package, and return them as a list.\n \n The dependencies will be a list of strings like `gleam/io` or `glance`\nSynonyms:\nglimpse/package.filter_new_dependencies\nglimpse/package filter_new_dependencies","url":"glimpse/package.html#filter_new_dependencies"},{"doc":"glimpse/package","title":"load_module","content":"pub fn load_module(\n  module: Module,\n  name: String,\n) -&gt; glimpse/package.Module\n Given an existing Gleam Module and its name, parse its imports to determine\n what its dependencies are. Return a Glimpse Module that wraps the Gleam module.\n\n Note: If the returned Module has any dependencies, it is up to the caller to ensure\n they are loaded, along with their dependencies.\nSynonyms:\nglimpse/package.load_module\nglimpse/package load_module","url":"glimpse/package.html#load_module"},{"doc":"glimpse/package","title":"load_package","content":"pub fn load_package(\n  package_name: String,\n  loader: fn(String) -&gt; Result(String, a),\n) -&gt; Result(Package, LoadError(a))\n Load a package using just it&#39;s name and a loader function. The name is\n required to be identical to the entry point module for the package (which\n is normal in gleam packages).\n\n Recursively loads all imports in the entrypoint using the supplied\n loader function.\nSynonyms:\nglimpse/package.load_package\nglimpse/package load_package","url":"glimpse/package.html#load_package"},{"doc":"glimpse/package","title":"glimpse/package","content":"","url":"glimpse/package.html"}]);